// { "framework": "Vue" }
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ({

/***/ 0:
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	(function () {

		var C = typeof window === 'undefined' ? __webpack_require__(7).Crypto : window.Crypto;

		// Shortcut
		var util = C.util;

		// Convert n to unsigned 32-bit integer
		util.u32 = function (n) {
			return n >>> 0;
		};

		// Unsigned 32-bit addition
		util.add = function () {
			var result = this.u32(arguments[0]);
			for (var i = 1; i < arguments.length; i++) {
				result = this.u32(result + this.u32(arguments[i]));
			}return result;
		};

		// Unsigned 32-bit multiplication
		util.mult = function (m, n) {
			return this.add((n & 0xFFFF0000) * m, (n & 0x0000FFFF) * m);
		};

		// Unsigned 32-bit greater than (>) comparison
		util.gt = function (m, n) {
			return this.u32(m) > this.u32(n);
		};

		// Unsigned 32-bit less than (<) comparison
		util.lt = function (m, n) {
			return this.u32(m) < this.u32(n);
		};
	})();

/***/ }),

/***/ 7:
/***/ (function(module, exports) {

	"use strict";

	// if (typeof Crypto == "undefined" || ! Crypto.util)
	// {
	// (function(){

	var base64map = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	// Global Crypto object
	// with browser window or with node module
	var Crypto = typeof window === 'undefined' ? {} : window.Crypto = {};

	// Crypto utilities
	var util = Crypto.util = {

		// Bit-wise rotate left
		rotl: function rotl(n, b) {
			return n << b | n >>> 32 - b;
		},

		// Bit-wise rotate right
		rotr: function rotr(n, b) {
			return n << 32 - b | n >>> b;
		},

		// Swap big-endian to little-endian and vice versa
		endian: function endian(n) {

			// If number given, swap endian
			if (n.constructor == Number) {
				return util.rotl(n, 8) & 0x00FF00FF | util.rotl(n, 24) & 0xFF00FF00;
			}

			// Else, assume array and swap all items
			for (var i = 0; i < n.length; i++) {
				n[i] = util.endian(n[i]);
			}return n;
		},

		// Generate an array of any length of random bytes
		randomBytes: function randomBytes(n) {
			for (var bytes = []; n > 0; n--) {
				bytes.push(Math.floor(Math.random() * 256));
			}return bytes;
		},

		// Convert a byte array to big-endian 32-bit words
		bytesToWords: function bytesToWords(bytes) {
			for (var words = [], i = 0, b = 0; i < bytes.length; i++, b += 8) {
				words[b >>> 5] |= (bytes[i] & 0xFF) << 24 - b % 32;
			}return words;
		},

		// Convert big-endian 32-bit words to a byte array
		wordsToBytes: function wordsToBytes(words) {
			for (var bytes = [], b = 0; b < words.length * 32; b += 8) {
				bytes.push(words[b >>> 5] >>> 24 - b % 32 & 0xFF);
			}return bytes;
		},

		// Convert a byte array to a hex string
		bytesToHex: function bytesToHex(bytes) {
			for (var hex = [], i = 0; i < bytes.length; i++) {
				hex.push((bytes[i] >>> 4).toString(16));
				hex.push((bytes[i] & 0xF).toString(16));
			}
			return hex.join("");
		},

		// Convert a hex string to a byte array
		hexToBytes: function hexToBytes(hex) {
			for (var bytes = [], c = 0; c < hex.length; c += 2) {
				bytes.push(parseInt(hex.substr(c, 2), 16));
			}return bytes;
		},

		// Convert a byte array to a base-64 string
		bytesToBase64: function bytesToBase64(bytes) {

			// Use browser-native function if it exists
			if (typeof btoa == "function") return btoa(Binary.bytesToString(bytes));

			for (var base64 = [], i = 0; i < bytes.length; i += 3) {
				var triplet = bytes[i] << 16 | bytes[i + 1] << 8 | bytes[i + 2];
				for (var j = 0; j < 4; j++) {
					if (i * 8 + j * 6 <= bytes.length * 8) base64.push(base64map.charAt(triplet >>> 6 * (3 - j) & 0x3F));else base64.push("=");
				}
			}

			return base64.join("");
		},

		// Convert a base-64 string to a byte array
		base64ToBytes: function base64ToBytes(base64) {

			// Use browser-native function if it exists
			if (typeof atob == "function") return Binary.stringToBytes(atob(base64));

			// Remove non-base-64 characters
			base64 = base64.replace(/[^A-Z0-9+\/]/ig, "");

			for (var bytes = [], i = 0, imod4 = 0; i < base64.length; imod4 = ++i % 4) {
				if (imod4 == 0) continue;
				bytes.push((base64map.indexOf(base64.charAt(i - 1)) & Math.pow(2, -2 * imod4 + 8) - 1) << imod4 * 2 | base64map.indexOf(base64.charAt(i)) >>> 6 - imod4 * 2);
			}

			return bytes;
		}

	};

	// Crypto character encodings
	var charenc = Crypto.charenc = {};

	// UTF-8 encoding
	var UTF8 = charenc.UTF8 = {

		// Convert a string to a byte array
		stringToBytes: function stringToBytes(str) {
			return Binary.stringToBytes(unescape(encodeURIComponent(str)));
		},

		// Convert a byte array to a string
		bytesToString: function bytesToString(bytes) {
			return decodeURIComponent(escape(Binary.bytesToString(bytes)));
		}

	};

	// Binary encoding
	var Binary = charenc.Binary = {

		// Convert a string to a byte array
		stringToBytes: function stringToBytes(str) {
			for (var bytes = [], i = 0; i < str.length; i++) {
				bytes.push(str.charCodeAt(i) & 0xFF);
			}return bytes;
		},

		// Convert a byte array to a string
		bytesToString: function bytesToString(bytes) {
			for (var str = [], i = 0; i < bytes.length; i++) {
				str.push(String.fromCharCode(bytes[i]));
			}return str.join("");
		}

	};

	// })();
	// }
	// exports.Crypto = Crypto;
	module.exports = {
		Crypto: Crypto
	};

/***/ })

/******/ });