// { "framework": "Vue" }
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var _stringify = __webpack_require__(1);

	var _stringify2 = _interopRequireDefault(_stringify);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	//index.js
	//获取应用实例
	var app = getApp();
	var fileData = __webpack_require__(!(function webpackMissingModule() { var e = new Error("Cannot find module \"../../utils/data.js\""); e.code = 'MODULE_NOT_FOUND'; throw e; }()));
	var util = __webpack_require__(!(function webpackMissingModule() { var e = new Error("Cannot find module \"../../utils/util\""); e.code = 'MODULE_NOT_FOUND'; throw e; }()));

	var hasrefres = false;
	Page({
	  // 页面初始数据
	  data: {
	    // nav 初始化
	    // cas picker
	    casArray: ['收费站', '更多信息稍后呈现'],
	    casIndex: 0,
	    // addr picker
	    addrArray: util.replacePhone(fileData.userData().addrs, false),
	    addrIndex: 0,
	    skillData: [], // fileData.getSkilledData(),
	    curNavId: 1,
	    curIndex: 0,
	    loadingHidden: true,
	    latitude: null,
	    longitude: null,
	    scrollHeight: 100
	  },

	  onLoad: function onLoad() {
	    var that = this;
	    that.setData({
	      list: that.data.skillData
	    });
	    //先定位定位

	    wx.getSystemInfo({
	      success: function success(res) {
	        console.info(res.windowHeight);
	        that.setData({
	          scrollHeight: res.windowHeight
	        });
	      }
	    });
	    //this.refesh(null);
	    this.onPullDownRefresh();
	  },
	  // 跳转至地图页面
	  navigateDetail: function navigateDetail(e) {
	    /*wx.navigateTo({
	      url: '../location/location?objid=' + e.currentTarget.dataset.aid
	    })*/
	    var item = app.findItem(e.currentTarget.dataset.aid, app.globalData.mainData);

	    wx.openLocation({
	      latitude: Number(item.lat),
	      longitude: Number(item.lng),
	      name: item.stationname,
	      address: item.roadname + item.stationname,
	      scale: 18
	    });
	    /*
	    app.globalData.switchObjId = e.currentTarget.dataset.aid;
	     wx.switchTab({
	          url: '../location/location'
	        });*/
	  },
	  // 加载更多
	  loadMore: function loadMore(e) {
	    console.log('加载更多');
	    if (this.data.skillData.length === 0) return;
	    var that = this;
	    // 由于是模拟数据，加载更多时候，数据重复加载
	    that.data.skillData = that.data.skillData.concat(that.data.skillData);
	    that.setData({
	      list: that.data.skillData
	    });
	  },
	  onPullDownRefresh: function onPullDownRefresh() {
	    console.log('--------下拉刷新-------');
	    wx.showNavigationBarLoading(); //在标题栏中显示加载
	    this.refesh(null);
	  },
	  //页面刷新
	  refesh: function refesh(e) {
	    console.log(e);
	    var that = this;
	    /* that.setData({
	           loadingHidden: false
	     });
	    */
	    //先获取得坐标
	    util.getlocation(function (succ, res) {
	      var userid = '';
	      if (app.globalData.userid != null) userid = app.globalData.userid;

	      if (true == succ) {
	        var content = {
	          lat: res.latitude,
	          lng: res.longitude,
	          querytype: 0, //0--收费站
	          userid: userid,
	          range: 10000,
	          maxcount: 50
	        };
	        app.globalData.lat = res.latitude;
	        app.globalData.lng = res.longitude;
	        var str = (0, _stringify2.default)(content);

	        console.log(str);
	        var enstr = util.encrypt(str);
	        console.log(enstr);
	        wx.request({
	          url: 'https://qngs.qingningsoft.cn/qn/app/', //'http://127.0.0.1:8022/qn/app/',   //
	          data: {
	            messagebody: { content: enstr }, //"fJGMPA/QtGAFxr0p/LtGuPFtk8eZkYnHqrY0wzT4JDFNb3KDh2ho9g=="},
	            messagehead: {
	              currentdate: "",
	              isencrypt: 1,
	              messagetype: 1500
	            }
	          },
	          header: {
	            "Content-Type": "application/json"
	          },
	          method: 'POST', // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
	          // header: {}, // 设置请求的 header
	          success: function success(res) {
	            // success
	            wx.stopPullDownRefresh(); //停止下拉刷新
	            that.setData({
	              loadingHidden: true
	            });
	            console.log(res.data);
	            if (res.statusCode == 200) {
	              var contstr = res.data.messagebody.content;
	              var content = JSON.parse(util.decrypt(contstr));
	              console.log(content);
	              if (content.result == 0) {
	                app.globalData.mainData = content.XQDList;
	                for (var i = 0; i < app.globalData.mainData.length; i++) {
	                  var c = app.globalData.mainData[i].roadcode.substring(0, 1);
	                  if (c == 'G') app.globalData.mainData[i].avatar = "../../image/image_highway_sign.png";else if (c == 'S') app.globalData.mainData[i].avatar = "../../image/image_sheng_sign.png";
	                  // app.globalData.mainData[i].dist = Math.round(app.globalData.mainData[i].dist * 100) / 100 + 'km';
	                  if (app.globalData.mainData[i].stationstatus == 0) {
	                    app.globalData.mainData[i].desc = "收费站已关闭";
	                    app.globalData.mainData[i].color = "red";
	                  } else {
	                    app.globalData.mainData[i].desc = "正常开放";
	                    app.globalData.mainData[i].color = "green";
	                  }
	                }
	                that.setData({
	                  list: app.globalData.mainData
	                });
	              } else {
	                //encodeURI
	                var errstr = decodeURI(content.resultInfo);
	                util.showtoast(errstr);
	              }
	            } else {
	              util.showtoast("服务器故障");
	            }
	          },
	          fail: function fail(e) {
	            // fail
	            wx.stopPullDownRefresh(); //停止下拉刷新
	            console.log(e);
	            that.setData({
	              loadingHidden: true
	            });
	          },
	          complete: function complete(e) {
	            // complete
	            console.log(e);
	          }
	        });
	      } else {
	        that.setData({
	          loadingHidden: true
	        });
	        util.showtost("定位失败");
	      }
	    });
	  },

	  // 类别选择
	  bindCasPickerChange: function bindCasPickerChange(e) {
	    console.log('Category picker发送选择改变，携带值为', e.detail.value);
	    /*this.setData({
	      casIndex: e.detail.value
	    })*/
	  },
	  // 地址选择
	  bindAddrPickerChange: function bindAddrPickerChange(e) {
	    console.log('Category picker发送选择改变，携带值为', e.detail.value);
	    this.setData({
	      addrIndex: e.detail.value
	    });
	  }

	});

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(2), __esModule: true };

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

	var core  = __webpack_require__(3)
	  , $JSON = core.JSON || (core.JSON = {stringify: JSON.stringify});
	module.exports = function stringify(it){ // eslint-disable-line no-unused-vars
	  return $JSON.stringify.apply($JSON, arguments);
	};

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	var core = module.exports = {version: '2.4.0'};
	if(typeof __e == 'number')__e = core; // eslint-disable-line no-undef

/***/ })
/******/ ]);