// { "framework": "Vue" }
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ({

/***/ 0:
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	(function () {

			var C = typeof window === 'undefined' ? __webpack_require__(7).Crypto : window.Crypto;

			// Shortcuts
			var util = C.util,
			    charenc = C.charenc,
			    UTF8 = charenc.UTF8,
			    Binary = charenc.Binary;

			// Inner state
			var x = [],
			    c = [],
			    b;

			var Rabbit = C.Rabbit = {

					/**
	     * Public API
	     */

					encrypt: function encrypt(message, password) {

							var

							// Convert to bytes
							m = UTF8.stringToBytes(message),


							// Generate random IV
							iv = util.randomBytes(8),


							// Generate key
							k = password.constructor == String ?
							// Derive key from passphrase
							C.PBKDF2(password, iv, 32, { asBytes: true }) :
							// else, assume byte array representing cryptographic key
							password;

							// Encrypt
							Rabbit._rabbit(m, k, util.bytesToWords(iv));

							// Return ciphertext
							return util.bytesToBase64(iv.concat(m));
					},

					decrypt: function decrypt(ciphertext, password) {

							var

							// Convert to bytes
							c = util.base64ToBytes(ciphertext),


							// Separate IV and message
							iv = c.splice(0, 8),


							// Generate key
							k = password.constructor == String ?
							// Derive key from passphrase
							C.PBKDF2(password, iv, 32, { asBytes: true }) :
							// else, assume byte array representing cryptographic key
							password;

							// Decrypt
							Rabbit._rabbit(c, k, util.bytesToWords(iv));

							// Return plaintext
							return UTF8.bytesToString(c);
					},

					/**
	     * Internal methods
	     */

					// Encryption/decryption scheme
					_rabbit: function _rabbit(m, k, iv) {

							Rabbit._keysetup(k);
							if (iv) Rabbit._ivsetup(iv);

							for (var s = [], i = 0; i < m.length; i++) {

									if (i % 16 == 0) {

											// Iterate the system
											Rabbit._nextstate();

											// Generate 16 bytes of pseudo-random data
											s[0] = x[0] ^ x[5] >>> 16 ^ x[3] << 16;
											s[1] = x[2] ^ x[7] >>> 16 ^ x[5] << 16;
											s[2] = x[4] ^ x[1] >>> 16 ^ x[7] << 16;
											s[3] = x[6] ^ x[3] >>> 16 ^ x[1] << 16;

											// Swap endian
											for (var j = 0; j < 4; j++) {
													s[j] = (s[j] << 8 | s[j] >>> 24) & 0x00FF00FF | (s[j] << 24 | s[j] >>> 8) & 0xFF00FF00;
											}

											// Convert words to bytes
											for (var b = 120; b >= 0; b -= 8) {
													s[b / 8] = s[b >>> 5] >>> 24 - b % 32 & 0xFF;
											}
									}

									m[i] ^= s[i % 16];
							}
					},

					// Key setup scheme
					_keysetup: function _keysetup(k) {

							// Generate initial state values
							x[0] = k[0];
							x[2] = k[1];
							x[4] = k[2];
							x[6] = k[3];
							x[1] = k[3] << 16 | k[2] >>> 16;
							x[3] = k[0] << 16 | k[3] >>> 16;
							x[5] = k[1] << 16 | k[0] >>> 16;
							x[7] = k[2] << 16 | k[1] >>> 16;

							// Generate initial counter values
							c[0] = util.rotl(k[2], 16);
							c[2] = util.rotl(k[3], 16);
							c[4] = util.rotl(k[0], 16);
							c[6] = util.rotl(k[1], 16);
							c[1] = k[0] & 0xFFFF0000 | k[1] & 0xFFFF;
							c[3] = k[1] & 0xFFFF0000 | k[2] & 0xFFFF;
							c[5] = k[2] & 0xFFFF0000 | k[3] & 0xFFFF;
							c[7] = k[3] & 0xFFFF0000 | k[0] & 0xFFFF;

							// Clear carry bit
							b = 0;

							// Iterate the system four times
							for (var i = 0; i < 4; i++) {
									Rabbit._nextstate();
							} // Modify the counters
							for (var i = 0; i < 8; i++) {
									c[i] ^= x[i + 4 & 7];
							}
					},

					// IV setup scheme
					_ivsetup: function _ivsetup(iv) {

							// Generate four subvectors
							var i0 = util.endian(iv[0]),
							    i2 = util.endian(iv[1]),
							    i1 = i0 >>> 16 | i2 & 0xFFFF0000,
							    i3 = i2 << 16 | i0 & 0x0000FFFF;

							// Modify counter values
							c[0] ^= i0;
							c[1] ^= i1;
							c[2] ^= i2;
							c[3] ^= i3;
							c[4] ^= i0;
							c[5] ^= i1;
							c[6] ^= i2;
							c[7] ^= i3;

							// Iterate the system four times
							for (var i = 0; i < 4; i++) {
									Rabbit._nextstate();
							}
					},

					// Next-state function
					_nextstate: function _nextstate() {

							// Save old counter values
							for (var c_old = [], i = 0; i < 8; i++) {
									c_old[i] = c[i];
							} // Calculate new counter values
							c[0] = c[0] + 0x4D34D34D + b >>> 0;
							c[1] = c[1] + 0xD34D34D3 + (c[0] >>> 0 < c_old[0] >>> 0 ? 1 : 0) >>> 0;
							c[2] = c[2] + 0x34D34D34 + (c[1] >>> 0 < c_old[1] >>> 0 ? 1 : 0) >>> 0;
							c[3] = c[3] + 0x4D34D34D + (c[2] >>> 0 < c_old[2] >>> 0 ? 1 : 0) >>> 0;
							c[4] = c[4] + 0xD34D34D3 + (c[3] >>> 0 < c_old[3] >>> 0 ? 1 : 0) >>> 0;
							c[5] = c[5] + 0x34D34D34 + (c[4] >>> 0 < c_old[4] >>> 0 ? 1 : 0) >>> 0;
							c[6] = c[6] + 0x4D34D34D + (c[5] >>> 0 < c_old[5] >>> 0 ? 1 : 0) >>> 0;
							c[7] = c[7] + 0xD34D34D3 + (c[6] >>> 0 < c_old[6] >>> 0 ? 1 : 0) >>> 0;
							b = c[7] >>> 0 < c_old[7] >>> 0 ? 1 : 0;

							// Calculate the g-values
							for (var g = [], i = 0; i < 8; i++) {

									var gx = x[i] + c[i] >>> 0;

									// Construct high and low argument for squaring
									var ga = gx & 0xFFFF,
									    gb = gx >>> 16;

									// Calculate high and low result of squaring
									var gh = ((ga * ga >>> 17) + ga * gb >>> 15) + gb * gb,
									    gl = ((gx & 0xFFFF0000) * gx >>> 0) + ((gx & 0x0000FFFF) * gx >>> 0) >>> 0;

									// High XOR low
									g[i] = gh ^ gl;
							}

							// Calculate new state values
							x[0] = g[0] + (g[7] << 16 | g[7] >>> 16) + (g[6] << 16 | g[6] >>> 16);
							x[1] = g[1] + (g[0] << 8 | g[0] >>> 24) + g[7];
							x[2] = g[2] + (g[1] << 16 | g[1] >>> 16) + (g[0] << 16 | g[0] >>> 16);
							x[3] = g[3] + (g[2] << 8 | g[2] >>> 24) + g[1];
							x[4] = g[4] + (g[3] << 16 | g[3] >>> 16) + (g[2] << 16 | g[2] >>> 16);
							x[5] = g[5] + (g[4] << 8 | g[4] >>> 24) + g[3];
							x[6] = g[6] + (g[5] << 16 | g[5] >>> 16) + (g[4] << 16 | g[4] >>> 16);
							x[7] = g[7] + (g[6] << 8 | g[6] >>> 24) + g[5];
					}

			};
	})();

/***/ }),

/***/ 7:
/***/ (function(module, exports) {

	"use strict";

	// if (typeof Crypto == "undefined" || ! Crypto.util)
	// {
	// (function(){

	var base64map = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	// Global Crypto object
	// with browser window or with node module
	var Crypto = typeof window === 'undefined' ? {} : window.Crypto = {};

	// Crypto utilities
	var util = Crypto.util = {

		// Bit-wise rotate left
		rotl: function rotl(n, b) {
			return n << b | n >>> 32 - b;
		},

		// Bit-wise rotate right
		rotr: function rotr(n, b) {
			return n << 32 - b | n >>> b;
		},

		// Swap big-endian to little-endian and vice versa
		endian: function endian(n) {

			// If number given, swap endian
			if (n.constructor == Number) {
				return util.rotl(n, 8) & 0x00FF00FF | util.rotl(n, 24) & 0xFF00FF00;
			}

			// Else, assume array and swap all items
			for (var i = 0; i < n.length; i++) {
				n[i] = util.endian(n[i]);
			}return n;
		},

		// Generate an array of any length of random bytes
		randomBytes: function randomBytes(n) {
			for (var bytes = []; n > 0; n--) {
				bytes.push(Math.floor(Math.random() * 256));
			}return bytes;
		},

		// Convert a byte array to big-endian 32-bit words
		bytesToWords: function bytesToWords(bytes) {
			for (var words = [], i = 0, b = 0; i < bytes.length; i++, b += 8) {
				words[b >>> 5] |= (bytes[i] & 0xFF) << 24 - b % 32;
			}return words;
		},

		// Convert big-endian 32-bit words to a byte array
		wordsToBytes: function wordsToBytes(words) {
			for (var bytes = [], b = 0; b < words.length * 32; b += 8) {
				bytes.push(words[b >>> 5] >>> 24 - b % 32 & 0xFF);
			}return bytes;
		},

		// Convert a byte array to a hex string
		bytesToHex: function bytesToHex(bytes) {
			for (var hex = [], i = 0; i < bytes.length; i++) {
				hex.push((bytes[i] >>> 4).toString(16));
				hex.push((bytes[i] & 0xF).toString(16));
			}
			return hex.join("");
		},

		// Convert a hex string to a byte array
		hexToBytes: function hexToBytes(hex) {
			for (var bytes = [], c = 0; c < hex.length; c += 2) {
				bytes.push(parseInt(hex.substr(c, 2), 16));
			}return bytes;
		},

		// Convert a byte array to a base-64 string
		bytesToBase64: function bytesToBase64(bytes) {

			// Use browser-native function if it exists
			if (typeof btoa == "function") return btoa(Binary.bytesToString(bytes));

			for (var base64 = [], i = 0; i < bytes.length; i += 3) {
				var triplet = bytes[i] << 16 | bytes[i + 1] << 8 | bytes[i + 2];
				for (var j = 0; j < 4; j++) {
					if (i * 8 + j * 6 <= bytes.length * 8) base64.push(base64map.charAt(triplet >>> 6 * (3 - j) & 0x3F));else base64.push("=");
				}
			}

			return base64.join("");
		},

		// Convert a base-64 string to a byte array
		base64ToBytes: function base64ToBytes(base64) {

			// Use browser-native function if it exists
			if (typeof atob == "function") return Binary.stringToBytes(atob(base64));

			// Remove non-base-64 characters
			base64 = base64.replace(/[^A-Z0-9+\/]/ig, "");

			for (var bytes = [], i = 0, imod4 = 0; i < base64.length; imod4 = ++i % 4) {
				if (imod4 == 0) continue;
				bytes.push((base64map.indexOf(base64.charAt(i - 1)) & Math.pow(2, -2 * imod4 + 8) - 1) << imod4 * 2 | base64map.indexOf(base64.charAt(i)) >>> 6 - imod4 * 2);
			}

			return bytes;
		}

	};

	// Crypto character encodings
	var charenc = Crypto.charenc = {};

	// UTF-8 encoding
	var UTF8 = charenc.UTF8 = {

		// Convert a string to a byte array
		stringToBytes: function stringToBytes(str) {
			return Binary.stringToBytes(unescape(encodeURIComponent(str)));
		},

		// Convert a byte array to a string
		bytesToString: function bytesToString(bytes) {
			return decodeURIComponent(escape(Binary.bytesToString(bytes)));
		}

	};

	// Binary encoding
	var Binary = charenc.Binary = {

		// Convert a string to a byte array
		stringToBytes: function stringToBytes(str) {
			for (var bytes = [], i = 0; i < str.length; i++) {
				bytes.push(str.charCodeAt(i) & 0xFF);
			}return bytes;
		},

		// Convert a byte array to a string
		bytesToString: function bytesToString(bytes) {
			for (var str = [], i = 0; i < bytes.length; i++) {
				str.push(String.fromCharCode(bytes[i]));
			}return str.join("");
		}

	};

	// })();
	// }
	// exports.Crypto = Crypto;
	module.exports = {
		Crypto: Crypto
	};

/***/ })

/******/ });